!c Description:
!c   Υβ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_chk_mol
  interface 

     subroutine chk_mol(mol, mol_pre)
       real(8), intent(inout)     :: mol(:)
       real(8), intent(in)        :: mol_pre(:)
     end subroutine chk_mol
     
  end interface
end module interface_chk_mol





subroutine chk_mol(mol, mol_pre)
  real(8), intent(inout)     :: mol(:)
  real(8), intent(in)        :: mol_pre(:)

  real(8), allocatable       :: lambda(:)       !ѷ
  real(8), parameter         :: factor = 9.0d-1 
  

  !礭
  smax = size(mol, 1)
  
  !ͤ
  allocate(lambda(smax))
  lambda = 1.0D0

  !礭
  lambda = merge(mol_pre / (mol_pre - mol), lambda, mol <= 0.0D0)
  mol = mol_pre - minval(lambda) * factor * (mol_pre - mol)

  !γ
  deallocate(lambda)

end subroutine chk_mol
